diff -udNr xdvik//special.c pxdvik//special.c
--- xdvik//special.c	2008-07-02 00:42:36.000000000 +0900
+++ pxdvik//special.c	2010-07-25 14:56:37.642073810 +0900
@@ -691,6 +691,12 @@
   contains these coordinates.
 */
 
+double	bbox_matrix[2][2] = {{1.0, 0.0}, {0.0, 1.0}};
+Boolean	bbox_scaled = False, bbox_rotated = False;
+
+#define	bbox_xscale	bbox_matrix[0][0]
+#define	bbox_yscale	bbox_matrix[1][1]
+
 static void
 append_bbox_info(int x, int y, int w, int h, int angle)
 {
@@ -735,25 +741,24 @@
 	    do_color_change();
 #endif
 
-	if (bbox_angle == 0) {
-	    ycorner -= bbox_voffset;
-	    XDrawRectangle(DISP, currwin.win, globals.gc.high, xcorner, ycorner, bbox_width, bbox_height);
+	if (! bbox_rotated) {
+	    ycorner -= bbox_voffset * bbox_yscale;
+	    XDrawRectangle(DISP, currwin.win, globals.gc.high, xcorner, ycorner, bbox_width, bbox_height * bbox_yscale);
 	    if (resource.postscript == 0) {
 		if (htex_inside_href) {
-		    htex_set_anchorsize(xcorner, ycorner, xcorner + bbox_width, ycorner + bbox_height);
+		    htex_set_anchorsize(xcorner, ycorner, xcorner + bbox_width,
+					ycorner + bbox_height * bbox_yscale);
 		    htex_set_objecttype(HTEX_IMG);
 		}
 	    }
 	}
 	else {
-	    float sin_a = sin(bbox_angle * (TWOPI / 360));
-	    float cos_a = cos(bbox_angle * (TWOPI / 360));
 	    float a, b, c, d;
 
-	    a = cos_a * bbox_width;
-	    b = -sin_a * bbox_width;
-	    c = -sin_a * bbox_height;
-	    d = -cos_a * bbox_height;
+	    a = bbox_matrix[0][0] * bbox_width;
+	    b = bbox_matrix[1][0] * bbox_width;
+	    c = -bbox_matrix[0][1] * bbox_height;
+	    d = -bbox_matrix[1][1] * bbox_height;
 
 	    XDrawLine(DISP, currwin.win, globals.gc.high,
 		      xcorner, ycorner,
@@ -907,6 +912,11 @@
 }
 
 
+typedef struct {
+  double matrix[2][2];
+  double x, y;
+} ROTATE_STACK;
+
 /*
  * dumb parsing of PostScript - search for rotation H. Zeller 1/97
  * Returns true if we find a potentially non-supported command that
@@ -916,16 +926,180 @@
 ps_parseraw(const char *PostScript_cmd)
 {
     const char *p;
+    double xscale, yscale, angle, sin_a, cos_a, a, b, c, d;
+    int n;
+    static int rotate_stack_len = 0;
+    static int rotate_stack_ptr = 0;
+    static ROTATE_STACK *rotate_stack = NULL;
+
+    p = strstr(PostScript_cmd, "currentpoint grestore moveto");
+    if (p != NULL) {
+	if (rotate_stack_ptr > 0) {
+	    double r;
+	    rotate_stack_ptr--;
+	    r = sqrt(((DVI_H - rotate_stack[rotate_stack_ptr].x)
+		      * (DVI_H - rotate_stack[rotate_stack_ptr].x)
+		      + (DVI_V - rotate_stack[rotate_stack_ptr].y)
+		      * (DVI_V - rotate_stack[rotate_stack_ptr].y))
+		     / (bbox_matrix[0][0] * bbox_matrix[0][0]
+			+ bbox_matrix[1][0] * bbox_matrix[1][0]))
+		* (rotate_stack[rotate_stack_ptr].matrix[0][0]
+		   * bbox_matrix[1][0]
+		   - rotate_stack[rotate_stack_ptr].matrix[1][0]
+		   * bbox_matrix[0][0])
+		/ (rotate_stack[rotate_stack_ptr].matrix[0][0]
+		   * rotate_stack[rotate_stack_ptr].matrix[0][0]
+		   + rotate_stack[rotate_stack_ptr].matrix[1][0]
+		   * rotate_stack[rotate_stack_ptr].matrix[1][0]);
+	    DVI_H += r * rotate_stack[rotate_stack_ptr].matrix[1][0];
+	    DVI_V += r * rotate_stack[rotate_stack_ptr].matrix[0][0];
+	    PXL_V = pixel_conv(DVI_V);
+	    bcopy(rotate_stack[rotate_stack_ptr].matrix, bbox_matrix,
+		  sizeof(bbox_matrix));
+	    bbox_rotated
+		= (bbox_matrix[0][1] != 0.0 || bbox_matrix[1][0] != 0.0)
+		? True : False;
+	    bbox_scaled
+		= (bbox_rotated
+		   || bbox_matrix[0][0] != 1.0 || bbox_matrix[1][1] != 1.0)
+		? True : False;
+	}
+	if (globals.debug & DBG_PS)
+	    fprintf(stderr, "current angle %f: %s\n",
+		    bbox_matrix[0][0] != 0
+		    ? -atan(bbox_matrix[1][0] / bbox_matrix[0][0])
+		    * (360 / TWOPI)
+		    : bbox_matrix[1][0] >= 0 ? (double)90 : (double)-90,
+		    PostScript_cmd);
+    }
 
-    bbox_angle = 0;
     p = strstr(PostScript_cmd, "rotate");
     if (p != NULL) {
 	while (*p != '\0' && !isdigit((int)*p))
 	    --p;
 	while (*p != '\0' && isdigit((int)*p))
 	    --p;
+	if (*p == '.') --p;
+	while (*p != '\0' && isdigit(*p)) --p;
 	if (*p != '+' && *p != '-')
 	    ++p;
+	n = sscanf(p, "%lf neg rotate", &angle);
+	if (n != 1) {
+	    fprintf(stderr, "%s:  cannot get angle.\n", globals.program_name);
+	    angle = 0.0;
+	}
+	if (rotate_stack_ptr >= rotate_stack_len) {
+	    rotate_stack_len += 0x10;
+	    rotate_stack = (ROTATE_STACK *)
+		xrealloc(rotate_stack,
+			 sizeof(ROTATE_STACK) * rotate_stack_len);
+	}
+	bcopy(bbox_matrix, rotate_stack[rotate_stack_ptr].matrix,
+	      sizeof(bbox_matrix));
+	rotate_stack[rotate_stack_ptr].x = DVI_H;
+	rotate_stack[rotate_stack_ptr].y = DVI_V;
+	rotate_stack_ptr++;
+
+	sin_a = sin(-angle * (TWOPI / 360));
+	cos_a = cos(-angle * (TWOPI / 360));
+	a =   bbox_matrix[0][0] * cos_a + bbox_matrix[0][1] * sin_a;
+	b = - bbox_matrix[0][0] * sin_a + bbox_matrix[0][1] * cos_a;
+	c =   bbox_matrix[1][0] * cos_a + bbox_matrix[1][1] * sin_a;
+	d = - bbox_matrix[1][0] * sin_a + bbox_matrix[1][1] * cos_a;
+	bbox_matrix[0][0] = a;
+	bbox_matrix[0][1] = b;
+	bbox_matrix[1][0] = c;
+	bbox_matrix[1][1] = d;
+	bbox_rotated = (b != 0.0 || c != 0.0) ? True : False;
+	bbox_scaled
+	    = (bbox_rotated
+	       || bbox_matrix[0][0] != 1.0 || bbox_matrix[1][1] != 1.0)
+	    ? True : False;
+	if (globals.debug & DBG_PS)
+	    fprintf(stderr, "current angle %f: %s\n",
+		    bbox_matrix[0][0] != 0
+		    ? -atan(bbox_matrix[1][0] / bbox_matrix[0][0])
+		    * (360 / TWOPI)
+		    : bbox_matrix[1][0] >= 0 ? (double)90 : (double)-90,
+		    PostScript_cmd);
+    }
+
+    p = strstr(PostScript_cmd, "scale");
+    if (p != NULL) {
+	if (strncmp(p - 4, "div", 3) == 0) {
+	    while (*p != '\0' && !isdigit(*p)) --p;
+	    while (*p != '\0' && isdigit(*p)) --p;
+	    if (*p == '.') --p;
+	    while (*p != '\0' && isdigit(*p)) --p;
+	    while (*p != '\0' && !isdigit(*p)) --p;
+	    while (*p != '\0' && isdigit(*p)) --p;
+	    while (*p != '\0' && !isdigit(*p)) --p;
+	    while (*p != '\0' && isdigit(*p)) --p;
+	    if (*p == '.') --p;
+	    while (*p != '\0' && isdigit(*p)) --p;
+	    while (*p != '\0' && !isdigit(*p)) --p;
+	    while (*p != '\0' && isdigit(*p)) --p;
+	    ++p;
+	    n = sscanf(p, "1 %lf div 1 %lf div scale", &xscale, &yscale);
+	    if (n == 2) {
+#ifdef PTEX
+		if(TATE) {
+		    double temp;
+		    temp = xscale;
+		    xscale = 1.0/yscale;
+		    yscale = 1.0/temp;
+		}
+		else {
+		    xscale = 1.0/xscale;
+		    yscale = 1.0/yscale;
+		}
+#else
+		xscale = 1.0/xscale;
+		yscale = 1.0/yscale;
+#endif
+	    } else {
+		fprintf(stderr,
+			"%s:  cannot get scaling factors.\n",
+			globals.program_name);
+		xscale = yscale = 1.0;
+	    }
+	} else {
+	    while (*p != '\0' && !isdigit(*p)) --p;
+	    while (*p != '\0' && isdigit(*p)) --p;
+	    if (*p == '.') --p;
+	    while (*p != '\0' && isdigit(*p)) --p;
+	    while (*p != '\0' && !isdigit(*p)) --p;
+	    while (*p != '\0' && isdigit(*p)) --p;
+	    if (*p == '.') --p;
+	    while (*p != '\0' && isdigit(*p)) --p;
+	    if (*p != '+' && *p != '-') ++p;
+	    n = sscanf(p, "%lf %lf scale", &xscale, &yscale);
+#ifdef PTEX
+	    if(TATE) {
+		double temp;
+		temp = xscale;
+		xscale = yscale;
+		yscale = temp;
+	    }
+#endif
+	    if (n != 2) {
+		fprintf(stderr,
+			"%s:  cannot get scaling factors.\n",
+			globals.program_name);
+		xscale = yscale = 1.0;
+	    }
+	}
+	bbox_matrix[0][0] *= xscale;
+	bbox_matrix[0][1] *= yscale;
+	bbox_matrix[1][0] *= xscale;
+	bbox_matrix[1][1] *= yscale;
+	bbox_scaled
+	    = (bbox_rotated
+	       || bbox_matrix[0][0] != 1.0 || bbox_matrix[1][1] != 1.0)
+	    ? True : False;
+	if (globals.debug & DBG_PS)
+	    fprintf(stderr, "current scale %f,%f: %s\n",
+		    bbox_xscale, bbox_yscale, PostScript_cmd);
 	sscanf(p, "%d neg rotate", &bbox_angle);
 	return True;
     }
@@ -1403,7 +1577,6 @@
     if (strncmp(cp, ":[begin]", 8) == 0) {
 	cp += 8;
 	bbox_valid = False;
-	bbox_angle = 0;
 	if (sscanf(cp, "%d %d\n", &raww, &rawh) >= 2) {
 	    bbox_valid = True;
 	    bbox_width = pixel_conv(spell_conv(raww));
@@ -1477,10 +1650,10 @@
 #endif	    
 	/* also raw PostScript, but no extra colon to skip */
 #if PS
-	if (INSIDE_MANE_WIN) {
-	    if (ps_parseraw(cp))
+	if (ps_parseraw(cp) && INSIDE_MANE_WIN)
 		have_raw_postscript = True;
 	    
+	if (INSIDE_MANE_WIN) {
 	    if (psfig_begun)
 		psp.drawraw(cp);
 	    else {
@@ -1518,6 +1691,10 @@
 #define	KEY_URY	keyval[3]
 #define	KEY_RWI	keyval[4]
 #define	KEY_RHI	keyval[5]
+#define	KEY_HSZ	keyval[6]
+#define	KEY_VSZ	keyval[7]
+#define	KEY_HSC	keyval[10]
+#define	KEY_VSC	keyval[11]
 
 #define	NKEYS	(sizeof keytab /sizeof *keytab)
 #define	N_ARGLESS_KEYS 1
@@ -1531,7 +1708,7 @@
     unsigned int len;
     char *q;
     int flags = 0;
-    double keyval[6] = { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 };
+    double keyval[12] = { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 };
 
     filename = cp;
     if (*cp == '\'' || *cp == '"') {
@@ -1633,6 +1810,314 @@
     bbox_valid = False;
 }
 
+/***************************************************************
+  Following two functions, DirName() and get_boudig_box()
+  come from ps.c in miyu-patch for xdvi PL17. 
+***************************************************************/
+
+static  char *
+DirName(f1, f2)
+        char    *f1;
+        char    *f2;
+{
+        char    *p1, *p2, *q1;
+        static char     buf[BUFSIZ];
+
+#ifndef VMS
+        if (*f2 == '/')
+                return f2;
+#endif  /* !VMS */
+
+        for (p1 = p2 = f1, q1 = buf; *p1; p1++, q1++) {
+#ifndef VMS
+            if (*p1 == '/')
+#else
+            if (*p1 == ':')
+#endif  /* !VMS */
+                p2 = p1 + 1;
+            *q1 = *p1;
+        }
+        strcpy(buf + (p2 - f1), f2);
+
+        return buf;
+}
+
+int
+get_bounding_box(psfile, llx, lly, urx, ury)
+        char    *psfile;
+        double   *llx;
+        double   *lly;
+        double   *urx;
+        double   *ury;
+{
+        FILE    *fptr;
+        char    buf[BUFSIZ];
+
+        if ((fptr = xfopen(psfile, "r")) == NULL) {
+            perror(psfile);
+            return -1;
+        }
+
+        for (;;) {
+            if (fgets(buf, BUFSIZ, fptr) == NULL) {
+                fprintf(stderr, "%s:unexpected EOF.\n", psfile);
+                fclose(fptr);
+                return -1;
+            }
+            if (strncmp(buf, "%%BoundingBox:", 14) == 0) {
+                if (sscanf(buf + 14, "%lf %lf %lf %lf", llx, lly, urx, ury) < 4) {
+                    fprintf(stderr, "\\special: ERROR.\n");
+                    fclose(fptr);
+                    return -1;
+                }
+                break;
+            }
+        }
+
+        fclose(fptr);
+
+        return 0;
+}
+
+
+/***************************************************************
+  The originai eps_special() is merged with psSpecial() in ps.c  
+  (miyu-patch for xdvi PL17). 
+***************************************************************/
+static        void
+epsbox_special(cp)
+      char    *cp;
+{
+      char    *filename;
+      static  char            *buffer = NULL;
+      char    *p;
+      char    *q;
+      double  keyval[12];
+      char    *tmpfilename;
+      char*   fileext[] = { ".ps", ".eps", ".epsf", "**" };
+      int     extmax = 6;
+      FILE    *fp;
+
+        float   hsize = 0.0, vsize = 0.0;
+        float   hscale = 0.0, vscale = 0.0;
+      char *ptr;
+
+      p = cp;
+      if ((ptr = strtok(p, "{}")) == NULL) {
+        fprintf(stderr, "\\special: ERROR.\n");
+        return;
+      }
+      hsize = atof(ptr);
+      if ((ptr = strtok(NULL, "{}")) == NULL) {
+        fprintf(stderr, "\\special: ERROR.\n");
+        return;
+      }
+      vsize = atof(ptr);
+      if ((ptr = strtok(NULL, "{}")) == NULL) {
+        fprintf(stderr, "\\special: ERROR.\n");
+        return;
+      }
+      filename = DirName(globals.dvi_name, ptr);
+
+      if ((fp = xfopen(filename, "r")) == NULL) {
+	  int i;
+	  tmpfilename=xmalloc(strlen(filename)+extmax);
+	  for (i = 0; strcmp(fileext[i], "**") != 0; i++) {
+	      strcpy(tmpfilename, filename);
+	      strcat(tmpfilename, fileext[i]);
+	      if ((fp = xfopen(tmpfilename, "r")) != NULL)
+		  break;
+	  }
+	  if (fp == NULL) {
+	      perror(tmpfilename);
+	      return;
+	  }
+	  strcpy(filename, tmpfilename);
+	  free(tmpfilename);
+      }
+      fclose(fp);
+
+      if (get_bounding_box(filename,
+                           &KEY_LLX, &KEY_LLY,
+                           &KEY_URX, &KEY_URY))
+        return;
+      
+      if (hsize != 0.0)
+        hscale = hsize / (KEY_URX - KEY_LLX);
+      if (vsize != 0.0)
+        vscale = vsize / (KEY_URY - KEY_LLY);
+
+      if (hscale == 0.0 && vscale == 0.0)
+        hscale = vscale = 1.0;
+      else if (hscale == 0.0)
+        hscale = vscale;
+      else if (vscale == 0.0)
+        vscale = hscale;
+      
+      KEY_RWI = hsize;
+      KEY_RHI = vsize;
+
+      if (buffer == NULL)
+          buffer = xmalloc(BUFSIZ);
+
+      strcpy(buffer, "@beginspecial");
+      q = buffer + strlen(buffer);
+      sprintf(q, " /@scaleunit 1 def");
+      q += strlen(q);
+      sprintf(q, " %f @hoffset", -KEY_LLX * hscale);
+      q += strlen(q);
+      sprintf(q, " %f @voffset", -KEY_LLY * vscale);
+      q += strlen(q);
+      sprintf(q, " %f @hscale", hscale);
+      q += strlen(q);
+      sprintf(q, " %f @vscale", vscale);
+      q += strlen(q);
+      strcpy(q, " @setspecial\n");
+
+
+      bbox_valid = True;
+      bbox_width = hsize * dimconv / currwin.shrinkfactor + 0.5;
+      bbox_voffset = bbox_height = vsize * dimconv / currwin.shrinkfactor + 0.5;
+
+      if (currwin.win == mane.win) {
+#if   PS
+          psp.drawbegin(PXL_H - currwin.base_x, PXL_V - currwin.base_y,
+              buffer);
+          /* talk directly with the DPSHandler here */
+          send_ps_file(filename, kpse_pict_format);
+          psp.drawend(" @endspecial");
+#else
+          draw_bbox();
+#endif
+      }
+      bbox_valid = False;
+}
+
+static        void
+elepsf_special(cp)
+      char    *cp;
+{
+      char    *filename;
+      static  char            *buffer;
+      static  unsigned int    buflen  = 0;
+      unsigned int            len;
+      char    *p;
+      char    *q;
+      int     flags   = 0;
+      double  keyval[12] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 
+                              0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
+        float   hsize = 0.0, vsize = 0.0;
+        float   hscale = 0.0, vscale = 0.0;
+
+      p = cp;
+      filename = p;
+      if (*p == '\'' || *p == '"') {
+          do ++p;
+          while (*p != '\0' && *p != *filename);
+          ++filename;
+      }
+      else
+          while (*p != '\0' && *p != ' ' && *p != '\t') ++p;
+      if (*p != '\0') *p++ = '\0';
+      while (*p == ' ' || *p == '\t') ++p;
+
+      filename = DirName(globals.dvi_name, filename);
+
+      if (get_bounding_box(filename,
+                           &KEY_LLX, &KEY_LLY,
+                           &KEY_URX, &KEY_URY))
+        return;
+
+      len = strlen(p) + NKEYS + 512;
+      if (buflen < len) {
+          if (buflen != 0) free(buffer);
+          buflen = len;
+          buffer = xmalloc(buflen);
+      }
+      strcpy(buffer, "@beginspecial");
+      q = buffer + strlen(buffer);
+      sprintf(q, " /@scaleunit 1 def");
+      q += strlen(q);
+      while (*p != '\0') {
+          char *p1 = p;
+          size_t keyno;
+
+          while (*p1 != '=' && !isspace(*p1) && *p1 != '\0') ++p1;
+          for (keyno = 0;; ++keyno) {
+              if (keyno >= NKEYS) {
+                  if (globals.warn_spec_now)
+                      fprintf(stderr,
+                          "unknown keyword (%*s) in \\special will be ignored\n",
+                          (int) (p1 - p), p);
+                  break;
+              }
+              if (memcmp(p, keytab[keyno], p1 - p) == 0) {
+                  if (keyno >= N_ARGLESS_KEYS) {
+                      if (*p1 == '=') ++p1;
+                      if (keyno < N_ARGLESS_KEYS + 12) {
+                          keyval[keyno - N_ARGLESS_KEYS] = atof(p1);
+                          flags |= (1 << (keyno - N_ARGLESS_KEYS));
+                      }
+                      *q++ = ' ';
+                      while (!isspace(*p1) && *p1 != '\0') p1++;
+                  }
+                  break;
+              }
+          }
+          p = p1;
+          while (!isspace(*p) && *p != '\0') ++p;
+          while (isspace(*p)) ++p;
+      }
+
+      hsize = KEY_HSZ;
+      vsize = KEY_VSZ;
+      hscale = KEY_HSC;
+      vscale = KEY_VSC;
+      if (hsize != 0.0)
+        hscale = hsize / (KEY_URX - KEY_LLX);
+      if (vsize != 0.0)
+        vscale = vsize / (KEY_URY - KEY_LLY);
+
+      KEY_RWI = KEY_URX - KEY_LLX;
+      KEY_RHI = KEY_URY - KEY_LLY;
+
+      if (hscale == 0.0 && vscale == 0.0)
+        hscale = vscale = 1.0;
+      else if (hscale == 0.0)
+        hscale = vscale;
+      else if (vscale == 0.0)
+        vscale = hscale;
+      
+      KEY_RHI *= vscale;
+      KEY_RWI *= hscale;
+
+      sprintf(q, " %f @hoffset", -KEY_LLX * hscale);
+      q += strlen(q);
+      sprintf(q, " %f @voffset", -KEY_URY * vscale);
+      q += strlen(q);
+      sprintf(q, " %f @hscale", hscale);
+      q += strlen(q);
+      sprintf(q, " %f @vscale", vscale);
+      q += strlen(q);
+      strcpy(q, " @setspecial\n");
+
+      bbox_valid = True;
+      bbox_width = KEY_RWI * dimconv / currwin.shrinkfactor + 0.5;
+      bbox_voffset = 0.0; 
+        bbox_height = KEY_RHI * dimconv / currwin.shrinkfactor + 0.5;
+
+	if (currwin.win == mane.win) {
+#if	PS
+	    psp.drawbegin(PXL_H - currwin.base_x, PXL_V - currwin.base_y, buffer);
+	/* talk directly with the DPSHandler here */
+	send_ps_file(filename, kpse_pict_format);
+	psp.drawend(" @endspecial");
+#else
+	draw_bbox();
+#endif
+    }
+    bbox_valid = False;
+}
 
 static void
 quote_special(char *cp)
@@ -2325,6 +2810,223 @@
 }
 
 /*
+** Modified 22/3/95.
+*/
+
+typedef struct psh_node {
+    char *this_file;
+    struct psh_node *next;
+} t_pshnode;
+
+static t_pshnode *psh_head = (t_pshnode *) NULL, *psh_tail = (t_pshnode *) NULL;
+
+/*
+** Include one header file.
+*/
+
+static void psh_includehfile(cp, beginning)
+char *cp;
+int beginning;
+
+{
+    static char rawstring[] = " stop\n%%xdvimark\nH userdict begin\0";
+
+    if (!beginning)
+        psp.drawbegin(PXL_H - currwin.base_x, PXL_V - currwin.base_y, "");
+    psp.drawraw(rawstring);
+    send_ps_file(cp, kpse_pict_format);
+    psp.drawend(" end\n");
+}
+
+/*
+** Include all header files.
+*/
+
+void psh_includeall()
+
+{
+    t_pshnode *this_node;
+
+    this_node = psh_head;
+    while (this_node != (t_pshnode *) NULL) {
+	psh_includehfile(this_node->this_file, 1);
+	this_node = this_node->next;
+    }
+}
+
+/*
+** Deal with the "header=<file>" special.
+*/
+
+static void psh_header(cp)
+char *cp;
+
+{
+    t_pshnode *this_node;
+    char *psheader;
+
+    /*
+    ** Find the file.
+    */
+
+    psheader = kpse_find_file ( cp+7, kpse_tex_ps_header_format, true );
+
+    if (psheader) {
+
+        /*
+	** Include the file directly in /userdict.
+	*/
+
+	/* psh_includehfile(psheader, 0); */
+	/* deleted by Kazuaki NAKAYAMA (nakayama@ripms.shinshu-u.ac.jp) */
+
+	/*
+	** Add a new node to the list of header files.
+	*/
+
+	this_node = (t_pshnode *) xmalloc(sizeof(t_pshnode));
+	this_node->this_file = strcpy(xmalloc((strlen(psheader) + 1) * sizeof(char)), psheader);
+	this_node->next = (t_pshnode *) NULL;
+	if (psh_head == (t_pshnode *) NULL)
+	    psh_head = psh_tail = this_node;
+	else {
+	    psh_tail->next = this_node;
+	    psh_tail = this_node;
+	}
+
+    } else
+	XDVI_WARNING((stderr, "Included PostScript header file %s not found", cp + 7));
+}
+
+/*
+** End Modifications
+*/
+ 
+/* color support (^^;)*/
+#if COLOR
+/* Cyan/Magenta/Yellow/Black to Red/Green/Blue */
+static void
+cmyk_to_rgb(c, m, y, k, r, g, b)
+	double  c, m, y, k;
+	double  *r, *g, *b;
+{
+    double red, green, blue;
+
+    if (k > 0.9999) {
+	red = green = blue = 0.0;
+    } else if (k < 0.0001) {
+	red   = 1.0 - c;
+	green = 1.0 - m;
+	blue  = 1.0 - y;
+    } else {
+	red   = (1.0 - c) * (1.0 - k);
+	green = (1.0 - m) * (1.0 - k);
+	blue  = (1.0 - y) * (1.0 - k);
+    }
+    *r = (red   < 0.0) ? 0.0 : (red   > 1.0) ? 1.0 : red;
+    *g = (green < 0.0) ? 0.0 : (green > 1.0) ? 1.0 : green;
+    *b = (blue  < 0.0) ? 0.0 : (blue  > 1.0) ? 1.0 : blue;
+}
+
+/* Hue/Saturation/Brightness to Red/Green/Blue */
+static void
+hsb_to_rgb(h, s, v, r, g, b)
+	double  h, s, v;
+	double  *r, *g, *b;
+{
+    double red, green, blue, h6, f, p, q, t;
+
+    if (s < 0.0001) {
+	red = green = blue = v;
+    } else {
+	h6 = h * 6.0;
+	f = h6 - (int)h6;
+	p = v * (1.0 - s);
+	q = v * (1.0 - s * f);
+	t = p - q + v;
+
+	switch ((int)h6) {
+	  case 0:  red = v; green = t; blue = p; break; /* Red     - Yellow  */
+	  case 1:  red = q; green = v; blue = p; break; /* Yellow  - Green   */
+	  case 2:  red = p; green = v; blue = t; break; /* Green   - Cyan    */
+	  case 3:  red = p; green = q; blue = v; break; /* Cyan    - Blue    */
+	  case 4:  red = t; green = p; blue = v; break; /* Blue    - Magenta */
+	  case 5:  red = v; green = p; blue = q; break; /* Magenta - Red     */
+	  default: red = green = blue = 0.0; break;
+	}
+    }
+    *r = (red   < 0.0) ? 0.0 : (red   > 1.0) ? 1.0 : red;
+    *g = (green < 0.0) ? 0.0 : (green > 1.0) ? 1.0 : green;
+    *b = (blue  < 0.0) ? 0.0 : (blue  > 1.0) ? 1.0 : blue;
+}
+
+static void
+color_warn()
+{
+    puts("Cannot allocate colormap entry: displayed colors are not exact.\n\
+That is because other applications may be using too many colors.\n\
+If you want more exact colors, let such a application exit and \"Reread\".");
+    fflush(stdout);
+}
+#endif /* COLOR */
+
+#ifdef COLOR
+#define RGB 0
+#define CMYK 1
+#define HSB 2
+#endif
+
+static void
+dvi2ps_color_special(cp, colfmt)
+	char *cp;
+	unsigned char colfmt;
+{
+#if 0 /* COLOR */ /* ADHOC FIX */
+    char	buf[BUFSIZ];
+    double	r, g, b;
+    XColor	fc, bc;
+
+    /* if (!use_color) return; */
+
+    if (colfmt == RGB) {
+	sscanf(cp, " %lf %lf %lf", &r, &g, &b);
+    }
+    else if (colfmt == CMYK) {
+	double c, m, y, k;
+	sscanf(cp, " %lf %lf %lf %lf", &c, &m, &y, &k);
+	cmyk_to_rgb(c, m, y, k, &r, &g, &b);
+    }
+    else if (colfmt == HSB) {
+	double h, s, v;
+	sscanf(cp, " %lf %lf %lf", &h, &s, &v);
+	hsb_to_rgb(h, s, v, &r, &g, &b);
+    }
+    sprintf(buf, "rgbi:%f/%f/%f", r, g, b);
+
+    fore_color_data.red =   (unsigned short)(r * ((unsigned short)~0) +.5);
+    fore_color_data.green = (unsigned short)(g * ((unsigned short)~0) +.5);
+    fore_color_data.blue =  (unsigned short)(b * ((unsigned short)~0) +.5);
+
+    if (XAllocNamedColor(DISP, our_colormap, buf, &fc, &bc) == True) {
+	if (color_allocated_top >= color_allocated_len) {
+	    color_allocated_len += 0x10;
+	    color_allocated = (Pixel *)
+		xrealloc(color_allocated,
+			 sizeof(Pixel) * color_allocated_len);
+	}
+	color_allocated[color_allocated_top++]
+	    = fore_color_data.pixel = fc.pixel;
+	init_colors();
+	reset_fonts();
+    } else if (!color_warn_done) {
+	color_warn();
+	color_warn_done = True;
+    }
+#endif
+}
+
+
+/*
  *	The following copyright message applies to the rest of this file.  --PV
  */
 
@@ -2453,6 +3155,16 @@
 #endif
 	return;
     }
+
+    if (memicmp(cp, "epsfile=", 8) == 0) {
+	elepsf_special(cp + 8);
+	return;
+    }
+    if (memicmp(cp, "postscriptbox{", 14) == 0) {
+	epsbox_special(cp + 14);
+	return;
+    }
+
     if (memicmp(cp, "html:", 5) == 0) {
 	htex_do_special(cp + 5, len - 5);
 	return;
@@ -2465,6 +3177,22 @@
 	    color_special(cp + 6);
 	return;
     }
+    if (memicmp(cp, "rgb=", 4) == 0) {
+	dvi2ps_color_special(cp + 4, RGB);
+	return;
+    }
+    if (memicmp(cp, "cmyk=", 5) == 0) {
+	dvi2ps_color_special(cp + 5, CMYK);
+	return;
+    }
+    if (memicmp(cp, "hsb=", 4) == 0) {
+	dvi2ps_color_special(cp + 4, HSB);
+	return;
+    }
+    if (memicmp(cp, "background ", 11) == 0) {
+	/* already scanned */
+	return;
+    }
 #endif
     
     /* these should have been scanned */
@@ -2555,6 +3283,8 @@
 	case CMD('b', 'k'):
 	    blacken_last();
 	    return;
+	case CMD('h', 'e'):
+	    psh_header(cp); return;
 	case CMD('i', 'p'):	/* throw away the path -- jansteen */
 	    path_len = 0;
 	    return;
diff -udNr xdvik//texmf/XDvi pxdvik//texmf/XDvi
--- xdvik//texmf/XDvi	2008-07-02 00:42:36.000000000 +0900
+++ pxdvik//texmf/XDvi	2010-07-25 14:56:37.642073810 +0900
@@ -125,7 +125,7 @@
 !!!------------------------------------------------------------------------------
 !!! background color and font:
 *tipShell.background: cornsilk
-*tipShell.fontSet: -*-helvetica-medium-r-*-*-12-*-*-*-*-*-*
+*tipShell.fontSet: -*-helvetica-medium-r-*-*-12-*-*-*-*-*-*,-*-*-medium-r-*-*-12-*-*-*-*-*-*,
 
 !!! time the mouse needs to stay on a button until tooltips pop up,
 !!! in milliseconds; set to a negative value to disable:
@@ -133,11 +133,24 @@
 
 
 !!!------------------------------------------------------------------------------
+!!!-------------------------------- Xaw i18n ------------------------------------
+!!!------------------------------------------------------------------------------
+!!! note: when i18n'ed, *font and *fontSet should have same size of font
+*international: true
+*inputMethod: kinput2
+*preeditType: OverTheSpot,OffTheSpot,Root
+!!! note: xdviSelFile can not be i18n'ed (bug?)
+xdviSelFile*international: false
+
+
+!!!------------------------------------------------------------------------------
 !!!------------------------------ Fonts and colors ------------------------------
 !!!------------------------------------------------------------------------------
-*font:     -*-helvetica-medium-r-*-*-12-*-*-*-*-*-*
+*font:    -*-helvetica-medium-r-*-*-12-*-*-*-*-*-*
+*fontSet: -*-helvetica-medium-r-*-*-12-*-*-*-*-*-*,-*-*-medium-r-*-*-12-*-*-*-*-*-*
 !!! Use a smaller font for the statusline in the Xaw version:
-*statusline.font: -*-helvetica-medium-r-*-*-10-*-*-*-*-*-*
+*statusline.font:    -*-helvetica-medium-r-*-*-10-*-*-*-*-*-*
+*statusline.fontSet: -*-helvetica-medium-r-*-*-10-*-*-*-*-*-*,-*-*-medium-r-*-*-10-*-*-*-*-*-*
 
 !!! Motif fonts. Meaning of the tags is:
 !!! NORMAL: Ordinary text, labels etc.
@@ -147,11 +160,11 @@
 !!! TOPIC_HEADING: Heading for help text in help window
 !!!
 *fontList: \
--*-helvetica-medium-r-*-*-12-*-*-*-*-*-*-*=NORMAL,\
--*-helvetica-medium-r-*-*-12-*-*-*-*-*-*-*=UNMARKED,\
--*-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*=MARKED,\
--*-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*=TOPIC_LABEL,\
--*-helvetica-bold-r-*-*-14-*-*-*-*-*-*-*=TOPIC_HEADING
+-*-*-medium-r-*-*-12-*-*-*-*-*-*-*:=NORMAL,\
+-*-*-medium-r-*-*-12-*-*-*-*-*-*-*:=UNMARKED,\
+-*-*-bold-r-*-*-12-*-*-*-*-*-*-*:=MARKED,\
+-*-*-bold-r-*-*-12-*-*-*-*-*-*-*:=TOPIC_LABEL,\
+-*-*-bold-r-*-*-14-*-*-*-*-*-*-*:=TOPIC_HEADING
 
 
 !!! Color used for page border, image bounding boxes and the ruler in `Ruler mode'.
diff -udNr xdvik//texmf/xdvi.cfg pxdvik//texmf/xdvi.cfg
--- xdvik//texmf/xdvi.cfg	2008-07-02 00:42:36.000000000 +0900
+++ pxdvik//texmf/xdvi.cfg	2010-07-25 14:56:37.642073810 +0900
@@ -63,3 +63,37 @@
 % dvipsmap psfonts.map
 dvipsmap ps2pk.map
 
+% =============== Section 3: pTeX Map files ===============
+
+replace H		JIS-H
+replace V		JIS-V
+replace UniJIS-UTF16-H	Unicode-H
+replace UniJIS-UTF16-V	Unicode-V
+replace UniKS-UTF16-H	Unicode-H
+replace UniKS-UTF16-V	Unicode-V
+replace UniGB-UTF16-H	Unicode-H
+replace UniGB-UTF16-V	Unicode-V
+replace UniCNS-UTF16-H	Unicode-H
+replace UniCNS-UTF16-V	Unicode-V
+
+% Japanese
+% IPA font (http://ossipedia.ipa.go.jp/ipafont/)
+replace Ryumin-Light		ipam.ttf
+replace GothicBBB-Medium	ipag.ttf
+
+% traditional Chinese
+% Arphic (http://www.ring.gr.jp/pub/GNU/non-gnu/chinese-fonts-truetype/)
+replace MSung-Light		bsmi00lp.ttf
+replace MHei-Medium		bkai00mp.ttf
+
+% simplified Chinese
+% Arphic (http://www.ring.gr.jp/pub/GNU/non-gnu/chinese-fonts-truetype/)
+replace STSong-Light		gbsn00lp.ttf
+replace STHeitiStd-Regular	gkai00mp.ttf
+
+% Korean
+% un-fonts (http://kldp.net/projects/unfonts/)
+replace HYSMyeongJo-Medium	UnBatang.ttf
+replace HYGoThic-Medium		UnDotum.ttf
+
+ptexmap kanjix.map
diff -udNr xdvik//util.c pxdvik//util.c
--- xdvik//util.c	2009-11-10 19:28:49.000000000 +0900
+++ pxdvik//util.c	2010-07-25 14:56:37.642073810 +0900
@@ -705,6 +705,38 @@
     bitmap->bits = xmalloc(size != 0 ? size : 1);
 }
 
+void
+clear_bitmap(struct bitmap *bitmap)
+{
+    memset(bitmap->bits, 0, bitmap->bytes_wide * bitmap->h);
+}
+
+void
+fill_bitmap(struct bitmap *bitmap)
+{
+    memset(bitmap->bits, 0xff, bitmap->bytes_wide * bitmap->h);
+}
+
+void
+order_reverse_bitmap(struct bitmap *bitmap)
+{
+    int i, size = bitmap->bytes_wide * bitmap->h;
+    unsigned char *p = (unsigned char *)bitmap->bits;
+    static unsigned char reverse_byte[0x100];
+
+    if (reverse_byte[1] == 0) {  /* init reverse_byte[] */
+	for (i=0; i<0x100; i++) {
+	    int src, dst = 0;
+	    for (src=1; src<0x100; src<<=1) {
+		dst <<= 1;
+		if (i & src) dst |= 1;
+	    }
+	    reverse_byte[i] = dst;
+	}
+    }
+
+    for (i=0; i<size; i++) p[i] = reverse_byte[p[i]];
+}
 
 #ifndef HAVE_MEMICMP
 /*
diff -udNr xdvik//util.h pxdvik//util.h
--- xdvik//util.h	2008-07-02 00:42:36.000000000 +0900
+++ pxdvik//util.h	2010-07-25 14:56:37.642073810 +0900
@@ -73,6 +73,9 @@
 
 struct bitmap; /* forward declaration */
 extern void alloc_bitmap(struct bitmap *);
+extern void clear_bitmap(struct bitmap *);
+extern void fill_bitmap(struct bitmap *);
+extern void order_reverse_bitmap(struct bitmap *);
 
 extern char *my_realpath(const char *path, char *real);
 #ifdef HAVE_REALPATH
diff -udNr xdvik//version.h pxdvik//version.h
--- xdvik//version.h	2009-05-19 03:31:06.000000000 +0900
+++ pxdvik//version.h	2010-07-25 14:56:37.642073810 +0900
@@ -3,6 +3,7 @@
 #define VERSION_H_
 
 #define XDVI_VERSION "22.84.16"
+#define JPVERSION "j1.41-ptexlive"
 
 #ifdef MOTIF
 #define XDVI_GUI "(Motif toolkit)"
@@ -13,7 +14,7 @@
 #define	XDVIK_PROGNAME "xdvik"
 #define	XDVI_PROGNAME "xdvi"
 
-#define XDVI_VERSION_INFO XDVI_VERSION" "XDVI_GUI
-#define XDVI_TERSE_VERSION_INFO XDVI_VERSION
+#define XDVI_VERSION_INFO XDVI_VERSION" "JPVERSION" "XDVI_GUI
+#define XDVI_TERSE_VERSION_INFO XDVI_VERSION" "JPVERSION
 
 #endif /* VERSION_H_ */
